/*
 *   ORXONOX - the hottest 3D action shooter ever to exist
 *                    > www.orxonox.net <
 *
 *
 *   License notice:
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public License
 *   as published by the Free Software Foundation; either version 2
 *   of the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *
 *   Author:
 *      Florian Zinggeler
 *   Co-authors:
 *      ...
 *
 */

/**
    @file DodgeRace.h
    @brief Gametype.
    @ingroup DodgeRace
*/

#ifndef _Pacman_H__
#define _Pacman_H__

#include "PacmanGelb.h"
#include "PacmanGhost.h"
#include "PacmanPointSphere.h"
#include "Highscore.h"
//#include "PlayerInfo.h"


#include "core/EventIncludes.h"
#include "core/command/Executor.h"
#include "core/config/ConfigValueIncludes.h"

#include "gamestates/GSLevel.h"
#include "chat/ChatManager.h"
#include <vector>

// ! HACK
#include "infos/PlayerInfo.h"

#include "core/command/ConsoleCommand.h"

#include "gametypes/Deathmatch.h"
#include "tools/Timer.h"

namespace orxonox
{

    class _PacmanExport Pacman : public Deathmatch
    {
       public:
            Pacman(Context* context);

            virtual void start() override;
            virtual void end() override;

            virtual void tick(float dt) override;

            void levelUp();
            bool collis(Vector3 one, Vector3 other);
            void catched();
            void posreset();
            void takePoint(PacmanPointSphere* taken);
            PacmanGelb* getPlayer();
            int getPoints();


            bool bEndGame;
            bool bShowLevel;
            int lives;
            int multiplier;
            float counter;
            int pattern;
            float lastPosition;

            Vector3 currentPosition;
            PacmanGelb* player;
            bool bcolli = false;
            Vector3 startposplayer = Vector3(0,10,245);
            int totallevelpoint = 3;
            //bool firstGame;
            
       private:


            Timer endGameTimer;
            int level;
            int point;
            bool b_combo;

            Timer enemySpawnTimer;
            Timer comboTimer;
            Timer showLevelTimer;

/*
std::string sDeathMessage;
const std::vector<std::string> DeathMessage7 = {
                "You should really try that again",
                "You can do better, can you?",
                "Hey, maybe you get a participation award, that's good isn't it?",
                "Congratulations, you get a medal, a wooden one",
                "That was flappin bad!",
                "Well, that was a waste of time",
                "You suck!",
                "Maybe try SuperOrxoBros. That game is not as hard.",
                "Here's a tip: Try not to fly into these grey thingies.",
                "We won't comment on that."};
            const std::vector<std::string> DeathMessage20 = {
                "Getting better!",
                "Training has paid off, huh?",
                "Good average!",
                "That was somehow enjoyable to watch",
                "Flappin average",
                "Getting closer to something",
                "That wasn't crap, not bad",
                "Surprisingly not bad."};
  */      
        
    };
}

#endif /* _Pacman_H__ */